/* Reads an Esterel program file, say watch.strl containing comments
   and produces two files, one with the comments removed and one
   with the program removed. The coments file is texset( like typeset).
   These files are created in the tmp area
   and the names of the files are printed. The file without comments
   can be used to  texset the Esterel program.
   The two texset files can be joined together on a line by line
   basis and headers and trailers added for tex.
   vinod Thu Oct 31 09:22:51 GMT 1996 NCST, Mumbai, India
   vinod@konark.ncst.ernet.in
*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <limits.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

main(argc, argv)
int argc;
char * argv[];
{
  FILE * in, * outs, * outc;
  char sfile [L_tmpnam];
  char cfile [L_tmpnam];
  char c;
  int incomment= 0;
  int instring= 0;

  if (argc < 2) {
    printf("Usage: sc2sandc <path>\n");
    exit (-1);
  }
  sprintf(sfile, "%s",argv[1]);
  if ((in = fopen (sfile, "r")) == NULL) {
    perror(sfile); exit(-1);
  }
  if (tmpnam (sfile)== NULL) {
    perror(sfile); exit(-1);
  }
  if (tmpnam (cfile) == NULL) {
    perror(cfile); exit(-1);
  }
  if ((outs=fopen (sfile, "w")) == NULL) {
    perror(sfile);exit(-1);
  }
  if ((outc=fopen (cfile, "w")) == NULL) {
    perror(cfile);exit(-1);
  }
  while (1) {
    if ((c = getc(in)) == EOF) break;
    if (c == '\n') {
      if (incomment)
        putc ('}', outc);
      putc (c, outs);
      putc (c, outc);
      incomment = 0;
    } else {
      if ((!incomment) && (c == '%')) {
        fputs("\\mbox{", outc);
        incomment = 1;
      }
      if (incomment) {
        if (c == '#') putc ('\\', outc);
        if (c == ' ') putc ('\\', outc);
        if (c == '%') putc ('\\', outc); 
        putc (c, outc);
      } else {
        if (c == '"') instring = 1-instring;
        if (instring && (c == ' ')) putc ('\\', outs);
        putc (c, outs);
      }
    }
  }

  fclose(outs);
  fclose(outc);
  printf("%s %s\n", sfile, cfile);
  fclose (in);
  exit(0);

}
